rem ***************************************************************************
rem
rem	System Configuration:			Date:	11/25/86
rem	--------------------			----
rem
rem	This configuration file sets up a PC/AT system
rem	with 2 floppy drives, 1 hardisk (2 partitions), and 1 console
rem
rem	Assumes:
rem	-------
rem 
rem	fd0:	- first floppy driver linked in
rem	con0:	- first console device linked in
rem	con1:	- second console device linked in
rem	pt0:	- port driver linked in
rem
rem	NOTE: Initialize the bootinit environment first with define,
rem	      to make sure that the boot procedure can continue
rem
rem ***************************************************************************
rem
rem	Set up the default process environment
rem
define con      = con:console
define default: = a:
define path     = default: system:
define order    = 286 bat
define switchar = -
define wmanager = system:wmex.286
define shell    = system:command.286
define home:    = fd0:
define ed       = dredix.286
rem
rem	Set up logical device names for fd0: and fd1:
rem
define -s a: = fd0:
define -s b: = fd1:
define -s c: = hd0:
define -s d: = hd1:
rem
rem	Set up the default system, and boot directories according
rem	to your hardware configuration
rem
define -s system: = fd0:\bin\
define -s boot:   = fd0:
rem
rem	Set up misc. system definitions
rem
define -s ren = rename
rem	More utility name defines are necessary if there are fewer builtin(s)
define -s protect = ON
define -s helplvl = 2
define -s prn     = prn:
define -s version = DRI-V1.3A
security -O=RWED -G=RE -W=RE
rem
rem	Install remaining disk devices according to the hardware
rem	configuration
rem
dvrunit fd0: fd1: lnrws
dvrload hd0: fd0:\drivers\athd.drv lnwrsm
if exist hd1: dvrunit hd0: hd1: lnwrsm
rem
rem	Load the printer driver ONLY if it is not linked in already,
rem	if it is already linked in, in CONFIG.C, comment the dvrload
rem	line out
rem
dvrload lpt0:      fd0:\drivers\printer.drv lrws
define -s bgprn:   = lpt0:
dvrload spldrv:    fd0:\drivers\spldrv.drv lnwrs
define -s prn:     = spldrv:
define -s tempdir: = hd0:/temp/
rem
rem
dvrunit pt0: pt1: lnrws
dvrload ser: fd0:\drivers\sdrv.drv lnrws
dvrlink ser: pt1:
rem
rem	Load the logon process
rem
define con: = con0:
back logon
rem
rem	End of configuration
rem


