/*======================================================================*
 *   Version 2.5	Console Driver					*
 *			C_WRITE function				*
 *----------------------------------------------------------------------*
 * VERSION   DATE    TIME  BY   CHANGE/COMMENTS				*
 *----------------------------------------------------------------------*
 *   1.00   3/19/85  8:12 DR-K  Added this intro to files		*
 *   1.01   4/10/85  9:54 DR-K  Ins/Del line, att fixxes		*
 *   1.02   4/17/85  4:00 DR-K	Added physical write optimizations	*
 *   1.03   4/25/85  2:35 DR-K	fix insert line exception		*
 *				 sub_drive phys_write optimize		*
 *   1.04   5/06/85 13:34 DR-K	fixed delchar, added beepbell call	* 
 *   1.05   5/08/85 15:25 DR-K	remove else pframe = FALSE		*
 *   1.06   5/10/85 17:56 DR-K	move cursur if phys&&bitmap&&showable	*
 *   1.07   5/12/85 16:54 DR-K	use (*copy) on physical scroll for color*
 *   1.08   5/21/85 14:07 DR-K	remove all pwrite,sdunit for c_sdwrite()*
 *   1.09   5/22/85 19:40 DR-K	constant 16-bit output characters set	*
 *   1.10   5/22/85 21:44 DR-K	scroll if WRAPM and last line/last char.*
 *				 use mapu and unmapu.			*
 *   1.11   6/12/85 14:28 DR-K	use IO.H not PD.H, del .sys res. defines*
 *   1.12   6/13/85 15:56 DR-K	fix insert line when vtop==0, and delete*
 *				 line when vtop+crow > fnrows		*
 *   1.13   6/14/85 15:33 DR-K	reconcile and cleanup as generic wrt	*
 *   1.14   6/20/85 15:48 DR-K	c_sdwrite returns evnum (flagevent/set)	*
 *				if (sdop) do mxevent,save pb,nextasr,	*
 *				 flag the CRM try to rewrite		*
 *				change to while( !e && bcnt--)		*
 *   1.15   6/25/85 16:23 DR-K	make x3000/x4000 do single c_sdwrites	*
 *   1.16   7/06/85 11:12 DR-K  uses p_write with asrwait, so all evnum *
 *				 and flag stuff (1.14,1.15) removed now	*
 *		    13:23 DR-K	use asrmx() rather then mxevent()	*
 *   1.17   7/12/85  9:31 DR-K	can re-enter mxregion without new evnum	*
 *   1.18   7/12/85 14:10 DR-K	call asrwait if color scroll to allow	*
 *				 others to run				*
 *   2.0    8/11/85 11:43 DR-K	DelChar to Pframe needs to check >fncol	*
 *   2.1   10/23/85 11:34 DR-K	make scroll-needed test be greater then	*
 *				 rather then equal.			*
 *   2.2   11/19/85	  DR-K	set curcol to num_of_cols-1 at eoln when*
 *				 not in wraparound mode and past last	*
 *   2.3   12/18/85	  DR-K	call asrwait if color pframe in insert	*
 *				 and delete line routines		*
 *   2.4    3/4/86	  DR-K	if this is color PC bitmap then do asmbl*
 *				hardware scroll call			*
 *   2.5   06/12/86       mei	High C port.				*
 *======================================================================*/

#include "portab.h"
#include "io.h"
#include "system.h" 
#include "icdrv.h"

#if METAWARE 
#define ICDRVWRT
#include "protos.h"
#endif

#define	ESC	0x001B

#if (COMPU == FALSE)
EXTERN	VOID	c2to2copy();
EXTERN	VOID	c2alter();
EXTERN	VOID	pos_cursor();
EXTERN	VOID	asrwait();
EXTERN	VOID	PCHScroll();
#endif

EXTERN	VCBLK	*pcb[];
EXTERN	BYTE	sd_units[] ;
EXTERN	DH	*sd_hdr[] ;
EXTERN	CTE	contab[];

EXTERN	DH	c_dh;		/* Our Driver Header */
EXTERN	LONG	c_rmflg[];
EXTERN	LONG	c_mxid[];

EXTERN	VOID	ch2fill();
EXTERN	VOID	cch2fill();
EXTERN	VOID	_bmovt();
EXTERN	LONG	s_return();	
EXTERN	VOID	b2to2copy();
EXTERN	VOID	b2alter();

EXTERN	VOID	off_pcursor();
EXTERN	VOID	on_pcursor();
EXTERN	VOID	beepbell();

	VOID	c_sdwrite();
	VOID	c_rewrite();			/* forward reference */
	VOID	eeol(), eeop(), ceeol(), ceeop();
	VOID	dirtyfig();

GLOBAL	CDWRITE	c_wpb[MAXcdUNIT] ;	/* array of pointers to pbs for CRM */
GLOBAL	BYTE	colorstack[256];	/* room for asrwait to save our stack */

LONG	c_write( pb )
	CDWRITE	*pb;
{
typedef	VOID	(*RPTR)();
	RPTR	copy,alter;
	VCBLK	*vcid;		/* flag and Virtual frame ptr */
	BYTE	unit;
	WORD	pframe,cpframe,sdop,*buff;
	WORD	ch16;
	WORD	bcnt,cnt,temp;
	FRAME	*fr;
	UWORD	currow,curcol,fncol,rsize ;
	WORD	dp,sp;
	BYTE	*d,ch8,att;
	LONG	e;			/* evnum from asrmx()		*/
	LONG	retc = E_SUCCESS;	/* default return code		*/
	DRECT	*dirt;			/* for returning the dirty area */

	unit = pb->cdw_unit ;
	alter = (RPTR) b2alter;
	copy = (RPTR) b2to2copy ;
	pframe = sdop = cpframe = FALSE;
	vcid = (VCBLK *)pb->cdw_vcid ;
	if ( pb->cdw_flags & CW_PWflg )
	    {
		vcid = pcb[unit];
		sdop = pframe = TRUE;
#if (COMPU == FALSE)
			/* adjust alter and copy calls to do vme and pframe */
		if ( unit == BITMAP ) 
		  {
		    sdop = FALSE;
		    if ( contab[unit].CT_flags & COLOR )
			{
			alter = (RPTR) c2alter;
			copy = (RPTR) c2to2copy ;
			cpframe = TRUE;
			}
		  }
		else
#endif
		if( (pb != &c_wpb[unit]) && 
			((e = asrmx(c_mxid[unit]) ) != NULLPTR ) )
			{	/* if we are not re-entering via c_rewrite() */
				/* and if asrmx returned an evnum. then we need*/
				/* to wait for the sync block */
				/* else we already own the sync and can run */
					/* if we can't have the sync and    */
			if ( pb != &c_wpb[unit] )   /* this is a new call here*/	
						/*because the pb address is not */
						/*our save area address, so */
			      {			/* copy all info into safe area */
				_bmovt(pb,&c_wpb[unit],sizeof(CDWRITE) );
				pb = &c_wpb[unit];
			      }
					/* schedule to restart when we have mx region */
			nextasr(e,c_rewrite,e,pb,200);
				/* tell CRM that we'll do this write eventually */
			retc = flagevent(c_rmflg[unit], 0L);
			return (retc);
			}
	    }
	fr = (FRAME *) vcid ;
	fncol = fr->fr_ncol ;
	att = vcid->v_att;
	dirt = (DRECT *) pb->cdw_dirty ;
	dirt->nrow = dirt->ncol = 0 ;		/*nothing yet*/
	dirt->row = currow = pb->cdw_row ;
	dirt->col = curcol = pb->cdw_col ;

	buff = pb->cdw_buffer ;
	if( pb->cdw_flags & DPF_UADDR )
	   {
	    mapu(pb->cdw_pd);
	    buff = (WORD *) SADDR(buff) ;
	   }
	bcnt = pb->cdw_bufsiz >> 1 ;

	while ( bcnt-- )
	{
	    ch8 = ch16 = *buff++ ;

	    if ( (ch16 & 0xFF00) || (ch16 < 0x20) )
	    {		/* special character */

		switch ( (BYTE) (ch16 >>12) )
		{	/*special function char maybe*/

		case OC_ROWGOTO:
			if ((ch16 & 0x0FFF) < fr->fr_nrow)
			    currow = ch16 & 0xFFF ;
			if(sdop)
			  {
				c_sdwrite(unit,ESC);
				c_sdwrite(unit,0x0059);
				c_sdwrite(unit,currow+32);
				c_sdwrite(unit,curcol+32);
			  }
			continue;

		case OC_COLGOTO:
			 if ( (ch16 & 0x0FFF) < fncol )
				curcol = ch16 & 0xFFF ;
			if(sdop)
			  {
				c_sdwrite(unit,ESC);
				c_sdwrite(unit,0x0059);
				c_sdwrite(unit,currow+32);
				c_sdwrite(unit,curcol+32);
			  }
			continue;

		case OC_COLOR:
			switch ( ch16 & 0x0F00 )
			{
			case 0:		/* foreground color */
				{
				att &= ~0x0F;
				att |= ( ch8 & 0x0F );
				continue;
				}
			case 0x0100:	/* background color */
				{
				att &= ~0xF0;
				att |= (ch8 & 0x0F) << 4 ;
				}
			}
			continue;

		case OC_EDITFN:
			if(sdop)	/* send it to sub-driver */
			  {
				c_sdwrite(unit,ESC);
				c_sdwrite(unit,ch16 & 0x00FF);
			  }
			switch(ch16 & 0xFF)
			{
			case OC_INDEXREV:   /*reverse lf needs more work*/
					/* fall through */
			case OC_UPCURSOR:
				if (--currow <0 ) currow = 0;
				continue;
			case OC_DOWNCURSOR:
				if (++currow == fr->fr_nrow) --currow;
				continue;
			case OC_RIGHTCURSOR:
				if (++curcol == fncol) --curcol;
				continue;
			case OC_LEFTCURSOR:
				if (--curcol <0 ) curcol = 0;
				continue;
			case OC_CLEAR:
				currow = curcol = 0;	/*fall thru*/
			case OC_EEOP:
				vcid->v_att = att;	/* put temp back */
				if(cpframe) ceeop(vcid,curcol,currow);
					else eeop(vcid,curcol,currow);
				if (pframe) continue;
				dirtyfig(dirt,curcol,currow);
				dirtyfig(dirt,fncol-1,fr->fr_nrow-1);
				continue;
			case OC_HOME:
				currow = curcol = 0;
				continue;
			case OC_EEL:
				curcol = 0;	/*fall thru*/
			case OC_EEOL:
				vcid->v_att = att;	/* put temp back */
				if(cpframe) ceeol(vcid,curcol,currow);
					else eeol(vcid,curcol,currow);
				if (pframe) continue;
				dirtyfig(dirt,curcol,currow);
				dirtyfig(dirt,fncol-1,currow);
				continue;
			case OC_DOCHINSERT:
				vcid->v_mode |= INSCHM;
				continue;
			case OC_NOCHINSERT:
				vcid->v_mode &= ~INSCHM;
				continue;
			case OC_SAVECURS:
				vcid->v_tempx = currow ;
				vcid->v_tempy = curcol ;
				continue;
			case OC_RESTORECURS:
				currow = vcid->v_tempx ;
				curcol = vcid->v_tempy ;
				continue;
			case OC_ENABLECURS:
				vcid->v_mode &= ~CURSOFFM;
				if(pb->cdw_flags & topVF) on_pcursor(unit);
				continue;
			case OC_DISABLECURS:
				vcid->v_mode |= CURSOFFM;
				if(pb->cdw_flags & topVF) off_pcursor(unit);
				continue;
			case OC_CHDELETE:	/*delete this char*/
					/* First we must calculate position */
					/* of cursor on VFRAME */
				d = (((((vcid->v_top + currow) % fr->fr_nrow) * fncol)
						+ curcol) *2) + fr->fr_pl[0];
				if (pframe)
				      {			/* not beyond screen */
					if (curcol >= fncol) continue;
					(*copy)(d+2,d,(fncol - curcol -1),0L );
				      }
				   else
				       {
					_bmovt(d+2,d,((fncol - curcol -1)<<1) );
					/* mark the rest of the line as dirty */
					dirtyfig(dirt,curcol,currow);
					dirtyfig(dirt,fncol-1,currow);
				       }
				*(d + ((fncol - curcol -1)<<1)) = 0x20;
				continue;
			case OC_INTENSIFY:
				att |= 0x08 ; continue;
			case OC_NOINTENSIFY:
				att &= ~0x08 ; continue;
			case OC_BLINK:
				att |= 0x80 ; continue;
			case OC_NOBLINK:
				att &= ~0x80 ; continue;
			case OC_REVERSE:
				if ( (vcid->v_mode & REVVIDM) ==0 )
				  {		/* enter reverse video */
				     temp = (att & 0x70) >> 4;
				     ch8  = (att & 0x07) << 4;
				     att = (att & 0x88) + temp + ch8 ;
				     vcid->v_mode |= REVVIDM;
				  }
				continue;
			case OC_NOREVERSE:
				if ( (vcid->v_mode & REVVIDM) != 0 )
				  {		/* exit reverse video */
				     temp = (att & 0x70) >> 4;
				     ch8  = (att & 0x07) << 4;
				     att = (att & 0x88) + temp + ch8 ;
				     vcid->v_mode &= ~REVVIDM;
				  }
				continue;
			case OC_WRAP:
				vcid->v_mode |= WRAPM  ; continue;
			case OC_NOWRAP:
				vcid->v_mode &= ~WRAPM ; continue;
			case OC_EBOP:	/* delete to beginning of display */
				vcid->v_att = att;	/* put temp back */
				for ( temp=0 ; temp<currow ; temp++)
					if(cpframe) ceeol(vcid,0,temp);
						else eeol(vcid,0,temp);
				if (!pframe) dirtyfig(dirt,fncol-1,0);
					/* fall thru */
			case OC_EBOL:	/* delete to beginning of line */
				temp=( ((vcid->v_top + currow) % fr->fr_nrow)
					* fncol) *2 ;
				(*alter)(fr->fr_pl[0]+temp,0,0x20,curcol,0L);
				(*alter)(fr->fr_pl[1]+temp,0,att,curcol,0L);
				if (!pframe) dirtyfig(dirt,0,currow);
				continue;
			case OC_LNINSERT:
					/* insert a blank line at cursor row */
				vcid->v_att = att;	/* put temp back */
				rsize = fncol *2;
				if (vcid->v_top != 0)
				  {
				   if((sp = vcid->v_top + currow) < fr->fr_nrow)
					{
						/* do it the hard way */
					dp = rsize;
					cnt = (vcid->v_top -1) * fncol;
					(*copy)(fr->fr_pl[0],fr->fr_pl[0]+dp,cnt,0L);
					(*copy)(fr->fr_pl[1],fr->fr_pl[1]+dp,cnt,0L);
					sp = (fr->fr_nrow -1) * rsize;
					cnt = fncol;
					(*copy)(fr->fr_pl[0]+sp,fr->fr_pl[0],cnt,0L);
					(*copy)(fr->fr_pl[1]+sp,fr->fr_pl[1],cnt,0L);
					sp = (currow + vcid->v_top) * rsize;
					dp = sp + rsize;
					cnt = (fr->fr_nrow - (vcid->v_top + currow +1)) * fncol;
					}
				     else {
					sp = sp % fr->fr_nrow ;
					cnt = ((vcid->v_top - sp) -1) * fncol;
					sp *= rsize;
					dp = sp + rsize;
					}
				  }
				else
				  {
				    sp = currow * rsize;
				    dp = sp + rsize;
				    cnt = ((fr->fr_nrow -1) - currow) * fncol;
				  }
				(*copy)(fr->fr_pl[0]+sp,fr->fr_pl[0]+dp,cnt,0L);
				if ( cpframe )	/* this is color monitor allow asr-resched*/
					asrwait(0L,colorstack);  
				(*copy)(fr->fr_pl[1]+sp,fr->fr_pl[1]+dp,cnt,0L);
				if(cpframe) ceeol(vcid,0,currow);
					else eeol(vcid,0,currow);
				curcol = 0;
				if (pframe)
				  {
				    if(sdop)
				       {
					c_sdwrite(unit,ESC);
					c_sdwrite(unit,0x006F);
				       }
				    continue;
				  }
				dirtyfig(dirt,0,currow);
				dirtyfig(dirt,fncol-1,fr->fr_nrow-1);
				continue;
			case OC_LNDELETE:   /* delete the line at cursor row */
				vcid->v_att = att;	/* put temp back */
				rsize = fncol *2;
				if (vcid->v_top != 0)
				  {
				    if((dp = vcid->v_top + currow) < fr->fr_nrow)
				      {
						/* do it the hard way */
					cnt = (fr->fr_nrow - (dp+1)) * fncol;
					dp *= rsize;
					sp = dp + rsize;
					if (cnt != fncol)
					{	/* silly last line copy */
					(*copy)(fr->fr_pl[0]+sp,fr->fr_pl[0]+dp,cnt,0L);
					(*copy)(fr->fr_pl[1]+sp,fr->fr_pl[1]+dp,cnt,0L);
					}
					dp = (fr->fr_nrow -1) * rsize;
					cnt = fncol;
					(*copy)(fr->fr_pl[0],fr->fr_pl[0]+dp,cnt,0L);
					(*copy)(fr->fr_pl[1],fr->fr_pl[1]+dp,cnt,0L);
					dp = 0;
					sp = rsize;
					cnt = (vcid->v_top -1) * fncol;
				      }
				  else {
					dp  = dp % fr->fr_nrow ;
					cnt = ((vcid->v_top -1) -dp) * fncol;
					dp *= rsize;
					sp  = dp + rsize;
				       }
				  }
				else
				  {
				     dp = currow * rsize;
				     sp = dp + rsize;
				     cnt = ((fr->fr_nrow - currow) -1) * fncol;
				  }
				(*copy)(fr->fr_pl[0]+sp,fr->fr_pl[0]+dp,cnt,0L);
				if ( cpframe )	/* this is color monitor allow asr-resched*/
					asrwait(0L,colorstack);  
				(*copy)(fr->fr_pl[1]+sp,fr->fr_pl[1]+dp,cnt,0L);
				if(cpframe) ceeol(vcid,0,fr->fr_nrow-1);
					else eeol(vcid,0,fr->fr_nrow-1);
				curcol = 0;
				if (pframe) continue;
				dirtyfig(dirt,0,currow);
				dirtyfig(dirt,fncol-1,fr->fr_nrow-1);
				continue;
			}
			break;
		case 0:		/* ASCII character */
			switch (ch16)
			{
			case 0:	  /* nulls filter to spaces */
				ch16 = ch8 = 0x0020;
				break;
			case 7:		/*bell*/
				beepbell(unit);
				continue;
			case 8:		/*bs*/
				if (curcol) curcol--;
				if(sdop) c_sdwrite(unit,8);
				continue;
			case 9:		/*tab*/
				do
				{  curcol++ ;
				} while(curcol & 7);
				if(sdop) c_sdwrite(unit,9);
				continue;
			case 13:	/*cr*/
				curcol = 0;
				if(sdop) c_sdwrite(unit,13);
				continue;

			case 10:	/*lf*/
				if(sdop) c_sdwrite(unit,10);
				if (++currow >= fr->fr_nrow) 
				{
					/* scroll the whole vc frame */
			   	    currow = fr->fr_nrow -1;
				    if ( vcid->v_mode & PCFRAME )
				    {	/* leave v_top=0 */

					temp = (currow * fncol );
					(*copy)(fr->fr_pl[1] + (fncol << 1)
						       ,fr->fr_pl[1], temp,0L);
					(*copy)(fr->fr_pl[0] + (fncol << 1)
						       ,fr->fr_pl[0], temp,0L);
					temp = temp << 1 ;
				    }
				    else
				    {	/* optimize by moving v_top */

					if ( pframe && !sdop )
						/* this is Physical BitMap */
						/* so do hardware scroll   */
					    {
					    PCHScroll(vcid);
				            temp = (currow * fncol *2);
					    }
					else 
					    {
				            temp = (vcid->v_top * fncol *2);
				            vcid->v_top =
						(vcid->v_top+1) % fr->fr_nrow;
					    }
				    }
					  /* blank the last line */
				    (*alter)((fr->fr_pl[0] + temp),0x00,0x20,fncol,0L);
				    (*alter)((fr->fr_pl[1] + temp),0x00,att,fncol,0L);

				    if (pframe) continue;
				    dirt->row = dirt->col = 0 ;
				    dirt->nrow = fr->fr_nrow ;
				    dirt->ncol = fncol ;
				}
				else
				{
				  if (!pframe)	/* Mark line dirty if dirty chars */
				    if ( dirt->ncol == 0 ) dirt->row++ ;
				     else dirt->nrow++ ;
				}
				continue;

			case 27:	/* ESC */
				if(sdop) c_sdwrite(unit,ESC);
				vcid->v_escflg = 1;
				continue;
			default:
				break;
	   		} /* end of case control: */
		} /* end of switch(special character) */
	    } /* End of if(special or control character) */


	    if (curcol >= fncol) 	/* if we're now beyond the limits of */
		{			/* this screen, then wraparound to   */
		if (vcid->v_mode & WRAPM) /* next line if mode is set. Else  */
			   {		/* leave doing nothing.		     */
			     curcol = 0;
			     if( ++currow == fr->fr_nrow )
				{
					/* scroll the whole vc frame */
			   	    currow--;
				    if ( vcid->v_mode & PCFRAME )
				    {	/* leave v_top=0 */

					temp = (currow * fncol );
					(*copy)(fr->fr_pl[0] + (fncol << 1)
							,fr->fr_pl[0], temp,0L);
					temp = temp << 1 ;
				    }
				    else
				    {	/* optimize by moving v_top */

					if ( pframe && !sdop )
						/* this is Physical BitMap */
						/* so do hardware scroll   */
					    {
					    PCHScroll(vcid);
				            temp = (currow * fncol *2);
					    }
					else 
					    {
				            temp = (vcid->v_top * fncol *2);
				            vcid->v_top =
						(vcid->v_top+1) % fr->fr_nrow;
					    }
				    }
					  /* blank the last line */
				    (*alter)((fr->fr_pl[0] + temp),0x00,0x20,fncol,0L);
				    (*alter)((fr->fr_pl[1] + temp),0x00,att,fncol,0L);

				    if (!pframe) {
					dirt->row = dirt->col = 0 ;
					dirt->nrow = fr->fr_nrow ;
					dirt->ncol = fncol ;
					}
				}
			   }
			else
			   {
				curcol = fncol;	/* set it at the max, and no */
				continue;	/* need to output this char */
			   }
		}

			/* update vc */

			/* Calculate position of cursor on VFRAME */

	    d = (((((vcid->v_top + currow) % fr->fr_nrow) * fncol)
			+ curcol) *2) + fr->fr_pl[0];
	    if (vcid->v_mode & INSCHM)	/* are we in insert char mode */
	    {
	      if (pframe) (*copy)(d,d+2,(fncol - curcol -1),0L );
		else
		{
		_bmovt(d,d+2,((fncol - curcol -1)<<1) );
		*d = 0x20;
			/* mark the rest of the line as dirty */
		dirtyfig(dirt,curcol,currow);
		dirtyfig(dirt,fncol-1,currow);
		}
	    }

		/* put the character and the attribute in next byte*/
	    if (pframe)
		  {
		  if(sdop) c_sdwrite(unit,ch16);
		  (*alter)(d,0x00,ch8,1,0L );
		  (*alter)(d+1,0x00,att,1,0L );
		  }
		else
		  {
		  *d++ = ch8;
		  *d = att;
		  dirtyfig(dirt,curcol,currow) ;
		  }
	    curcol++;

	} /* end for bufsiz loop*/

		/* release the sync block */
	if (sdop) mxrel(c_mxid[unit]);

	/* pass back the updated current cursor postions */
	dirt->currow = currow ;
	dirt->curcol = curcol ;
	vcid->v_att = att;

#if (COMPU == FALSE)
	if ( (pframe) && (!(sdop)) && ((vcid->v_mode & CURSOFFM) ==0) )
		pos_cursor(currow + vcid->v_ptop, curcol, fncol);
#endif
	if ( pb->cdw_flags & DPF_UADDR )  unmapu();
	return(E_SUCCESS);

} /*end of c_write*/

	/* Erase to End of Line */

VOID eeol(vcid,curcol,currow)
	VCBLK	*vcid ;
	UWORD	curcol,currow ;
{
	FRAME	*f ;
	WORD	temp,cnt;

	f = (FRAME *) vcid ;
	temp =((((vcid->v_top + currow) % f->fr_nrow) * f->fr_ncol)+ curcol)*2;
	cnt = f->fr_ncol - curcol ;
	ch2fill((f->fr_pl[0] + temp),cnt,0x20);
	ch2fill((f->fr_pl[1] + temp),cnt,vcid->v_att );
}

	/* Erase to End of Page */

VOID eeop(vcid,curcol,currow)
	VCBLK	*vcid ;
	UWORD	curcol,currow ;
{
	FRAME	*f ;
	UWORD	r ;

	f = (FRAME *) vcid ;
	eeol(vcid,curcol,r=currow);
	while ( f->fr_nrow != ++r )
		eeol(vcid,0,r);
}

	/* Erase to End of Line on the IBM color board */

VOID ceeol(vcid,curcol,currow)
	VCBLK	*vcid ;
	UWORD	curcol,currow ;
{
	FRAME	*f ;
	WORD	temp,cnt;

	f = (FRAME *) vcid ;
	temp =((((vcid->v_top + currow) % f->fr_nrow) * f->fr_ncol)+ curcol)*2;
	cnt = f->fr_ncol - curcol ;
	cch2fill((f->fr_pl[0] + temp),cnt,0x20);
	cch2fill((f->fr_pl[1] + temp),cnt,vcid->v_att );
}

	/* Erase to End of Page */

VOID ceeop(vcid,curcol,currow)
	VCBLK	*vcid ;
	UWORD	curcol,currow ;
{
	FRAME	*f ;
	UWORD	r ;

	f = (FRAME *) vcid ;
	ceeol(vcid,curcol,r=currow);
	while ( f->fr_nrow != ++r )
		ceeol(vcid,0,r);
}


VOID dirtyfig(r,curcol,currow)
	DRECT	*r;
	UWORD	curcol,currow ;
{
	UWORD	maxcol,maxrow ;

	maxcol = max( r->col + r->ncol , curcol +1);
	r->col = min( curcol,r->col );
	r->ncol = maxcol - r->col ;
	maxrow = max( r->row + r->nrow , currow +1);
	r->row = min( currow,r->row );
	r->nrow = maxrow - r->row ;
}

VOID c_sdwrite(unit,ch)
	WORD	unit;
	BYTE	ch;
{
      (*sd_hdr[unit]->dh_write)(sd_units[unit],ch);
}

VOID  c_rewrite(e,pb)
	LONG	e;
	CDWRITE	*pb;
{			/* cleans up events and restarts c_write() */
	s_return( e );
	c_write( pb );
		/* c_write will return to here, we flagset the CRM */
	flagset( c_rmflg[(pb->cdw_unit)], *(c_dh.dh_curpd), 0L);
}
